// Spirale

/* VARIABLES GÉNÉRALES
** valeurs à déterminer par l'utilisateur dans "definirFigure" (premières lignes).
**
** a et b déterminent l'intervalle [a, b] du domaine de définition des fonctions 
** coordonnées f, g, h.
** De même c et d déterminent l'intervalle [c, d] de ce même domaine
** n est le nombre de sous-intervales de [a, b]  
** de même m est le nombre de sous-intervales de [c, d]
** couleur1 et couleur2 sont les couleurs des faces adjacentes
** couleur1R est la quantité de rouge dans couleur1, 
** de même les suffixes g et b indiquent le vert et le bleu dans 
** la couleur correspondante.
*/
var U_n, U_m;

/* LES FONCTIONS COORDONNÉES : 
** doivent toujours être présentes et
** leur contenu détermine la figure
** qui sera tracée. 
*/
function f(u, v){
  return (1-u)*(3+cos(v))*cos(4*PI*u);
}

function g(u, v){
  return (1-u)*(3+cos(v))*sin(4*PI*u);
}

function h(u, v){
  return 3*u+(1-u)*sin(v);
}

/* definirFigure contient le calcul des sommets et des faces
** qui ici dépendent des valeurs de a, b, c, d, n, m et aussi des 
** fonctions coordonnées.
**/
function definirFigure(){
// Initialisation des variables: choix utilisateur
// Intervalle [a, b]
  var a = 0, b = 1;
// Intervalle [c, d]
  var c = 0, d = 2*PI;
// Nombre de sous intervalles sur [a, b] et [c, d]
  U_n = 60, U_m = 40;
  // Choix de la première couleur
  var couleur1R = 255, couleur1G = 0, couleur1B = 0;
  // Choix de la seconde couleur
  var couleur2R = 0, couleur2G = 255, couleur2B = 0;
  // Combien de pixels pour une unité qui sert à définir les sommets
  pixelsParUnite(100);
  
  // Ne pas modifier la partie entre les lignes étoilées
  //*************************************************************************
  var n = U_n, m = U_m;
  var du = (b-a)/n; // accroissement sur u pour passer d'un sommet à l'autre
  var dv = (d-c)/m; // accroissement sur v pour passer d'un sommet à l'autre
  // Calcul des sommets
  for(var y = 0; y <= m; y++){
    for(var x = 1; x <= n+1; x++){
      definirSommet(y*(n+1)+ x, f(a+(x-1)*du, c+y*dv), g(a+(x-1)*du, c+y*dv), h(a+(x-1)*du, c+y*dv));
    }//x
  }//y
  // calcul des faces
  for(var y=1; y <= m; y++){
    for(var x = 1; x <= n; x++){
      definirFace((y-1)*n+x, (y-1)*(n+1)+x, (y-1)*(n+1)+x+1, y*(n+1)+x+1, y*(n+1)+x);
      if ((x+y)%2 == 0){
        couleurFace((y-1)*n+x, couleur1R, couleur1G, couleur1B);
      }else{
        couleurFace((y-1)*n+x, couleur2R, couleur2G, couleur2B);
      }
    }//x
  }//y
}
// ********************************************************************************
function initialiserFigure(){
	fixeRotationX(30);
	fixeRotationY(25);
}

function redefinirCertainsSommets(){
  
}


