// Moebius

// Les variables
  var rayon = 1;
  var demi_largeur = 0.4;
  var n = 60; // moitié du nombre sommets

function definirFigure(){
  pixelsParUnite(250);
  //Définition des sommets
  for(var k = 0; k <= n; k++){
    var angle1 = k*PI/n;
    var angle2 = 2*angle1;
    var r1 = rayon + demi_largeur * sin(angle1);
    var r2 = rayon - demi_largeur * sin(angle1);
    var u = demi_largeur * cos(angle1);
    definirSommet(2*k+1, r1*cos(angle2), r1*sin(angle2), u);
    definirSommet(2*k+2, r2*cos(angle2), r2*sin(angle2), -u);
  }
  //Définition des faces
  for(var k = 0; k < 2*n; k++){
    if(k%2 == 0){
      definirFace(k+1, k+1, k+2, k+3);
      couleurFace(k+1, 255, 0, 0);
    }else{
      definirFace(k+1, k+1, k+2, k+3);
      couleurFace(k+1, 0, 255, 0);
    }
  } 
  creerGlissiereG1(1, 6, 1, 0.4, 'Torsion');
}

function initialiserFigure(){
	fixeRotationX(-150);
	fixeRotationY(-15);
}

function redefinirCertainsSommets(){
  for(var k = 0; k <= n; k++){
    var angle1 = k*PI/n;
    var angle2 = 2*angle1;
    var v = round(valG1);
    var r1 = rayon + demi_largeur * sin(v*angle1);
    var r2 = rayon - demi_largeur * sin(v*angle1);
    var u = demi_largeur * cos(v*angle1);
    redefinirSommet(2*k+1, r1*cos(angle2), r1*sin(angle2), u);
    redefinirSommet(2*k+2, r2*cos(angle2), r2*sin(angle2), -u);
  }
}
